
	subroutine ps_init

	include 'common.h'

        real x(nx)   ! computaional domain
        real z(nz)   ! computaional domain

	write(*,*)' Begin init '

	
	dx=xmax/(nx-1)
	dz=zmax/(nz-1)

	do i=1,nx
	xs(i)=(i-1)*dx
	enddo
     
	do i=1,nz
	zs(i)=(i-1)*dz
	enddo



cccccccccccccccccccccccccccccccccccccccccccc
ccc Source time function 
cccccccccccccccccccccccccccccccccccccccccccc

c source (half the time step becuase of 4th order RK)

	if(aa.ne.0)then

	dt2=dt/2.
	call ricker(dt2,2*nt,aa,so)

c normalize
	
	smax=0.
	do i=1,2*nt
	if(abs(so(i)).gt.smax)then
	smax=abs(so(i))
	endif
	enddo
	do i=1,2*nt
	so(i)=so(i)/smax*1./2.*nx
	enddo

	else

	it0=50
	so=0.
	so(it0:it0+1)=1/2.*nx

	endif

	open(unit=33,file=seisfile(1:lnblnk(seisfile))//'_src')
	do i=1,2*nt
	write(33,*)so(i)
	enddo
 11	format(e10.5)
	close(33)


cccccccccccccccccccccccccccccccccccccccccccccccc
cccc Spatial source distribution
cccccccccccccccccccccccccccccccccccccccccccccccc

	if(alpha.ne.0.)then

c source gauss

	alpha=1./(alpha*alpha)
	do ix=1,nx
	do iz=1,nz
	gauss(ix,iz)=
     &  exp( -alpha *( (xs(ix)-xxs)**2 +(zs(iz)-zzs)**2 ))
	end do
	end do

	else

	isx=maxval(minloc(abs(xs-xxs)))
	isz=maxval(minloc(abs(zs-zzs)))

	write(*,*)' Source delta at : ',isx,isz

	gauss=0.
	gauss(isx,isz)=1.
	write(*,*)minval(gauss),' < gauss < ',maxval(gauss)

	endif

c output

	open(unit=20,file=seisfile(1:lnblnk(seisfile))//'_gauss')
	do i=1,nx
	do j=1,nz
	write(20,*)gauss(i,j)
	enddo
	enddo

ccccccccccccccccccccccccccccccccccccccccccccc

	write(*,*)' End init '

	return
	end

c--------------------------------------------------

c ricker wavelet

        subroutine ricker(dt,nt,f0,source)
	
	real source(*)
        
	do it=1,nt
        t0=((1./f0)/dt)+20.
        pi=3.141592654
        om2=4.*pi*pi*f0*f0
        a2=4./om2
        arg=dt*dt*(it-t0)*(it-t0)/a2
        if(it.gt.(2.*t0))goto 1
        if(arg.gt.15)then
	ri=0.
	goto 1
	endif
        ri=-(1.-2.*arg)*exp(-arg)
c	write(*,*)ri
	
 1	source(it)=ri
	enddo	
	
        return
        end

